const РАССТОЯНИЕ = 40;
const КОЭФФИЦИЕНТ_ВЫСОТЫ = 1.5;

    
var ТЕМА = "";//"https://git.opengamestudio.org/MAOH/TEMA_M1K/raw/branch/master/0000";
var ФИШКА = "";//"/TileHigh.gltf";
var РАСКЛАДКИ = "";//"https://git.opengamestudio.org/MAOH/PACK_M1/raw/branch/master/0000";
var РАСКЛАДКА = "";//"/X_shaped.layout";

// // // //


ПроверитьОкна = мир =>
{
    var окно = создатьОкноСОтступами("пример");
    окно.плавно.отобразить();
};


// // // //


ВывестиПоражение = мир =>
{
    console.debug("ПОРАЖЕНИЕ");
};


// // // //


ВывестиПобеду = мир =>
{
    console.debug("ПОБЕДА");
};


// // // //


ЗадатьФишкуДляВыбора = мир =>
{
    var номер = мир.выбранныйУзел.userData;
    мир.фишкаМаджонгаДляВыбора = номер;
}


// // // //


ПодготовитьФишкиКВыбору = мир =>
{
    мир.выборныеУзлы = мир.фишкиСцены;
};


// // // //


ПодготовитьсяКСозданиюФишек = мир =>
{
    РАСКЛАДКИ = мир.реестрМаджонга["📍"][0]["📦"];
    РАСКЛАДКА = мир.реестрМаджонга["📍"][0]["📁"][0];
    
    var м = мир.модули.модульПоУказателю(РАСКЛАДКИ);
    var содержимое = м.содержимое[РАСКЛАДКА];
    var позиции = разобратьРаскладкуKMahjongg(содержимое);
    
    var фишки = [];
    var группа = 0;
    for (var номер in позиции)
    {
        var п = позиции[номер];
        фишки.push({
            "📍": [п[0], п[1], п[2]],
            "🚩": группа,
        });
        if (номер % 2)
        {
            ++группа;
            if (группа > 41)
            {
                группа = 0;
            }
        }
    };

    мир.фишкиМаджонга = фишки;
    мир.модельФишкиСцены = мир.полигональныеСетки[ТЕМА][ФИШКА];
    мир.сцена.add(мир.сценаМаджонга);
};


// // // //


СоздатьПримерСцены = мир =>
{
    мир.сцена.background = new THREE.Color(0xFFFFFF);
    мир.камера.position.y = РАССТОЯНИЕ * КОЭФФИЦИЕНТ_ВЫСОТЫ;
    мир.камера.position.z = РАССТОЯНИЕ;
    мир.камера.lookAt(new THREE.Vector3(0, 0, 0));
    
    мир.свет = new THREE.DirectionalLight(0xFFFFFF, 1);
    мир.свет.position.set(-0.5, 1, 0.5).normalize();
    мир.сцена.add(мир.свет);
};


// // // //


СоздатьМатериалыФишек = мир =>
{
    мир.материалыФишекСцены = [];
    мир.выбранныеМатериалыФишекСцены = [];

    var текстуры = мир.текстуры[ТЕМА];
    for (var имя in текстуры)
    {
        var текстура = текстуры[имя];
        var материал = new THREE.MeshLambertMaterial({
            map: текстура,
            color: new THREE.Color(0xCCCCCC),
        });
        мир.материалыФишекСцены.push(материал);
        var выбранныйМатериал = new THREE.MeshLambertMaterial({
            map: текстура,
            color: new THREE.Color(0xFFFFFF),
        });
        мир.выбранныеМатериалыФишекСцены.push(выбранныйМатериал);
    }
};

// // // //


ПодготовитьсяКЗагрузкеРесурсов = мир =>
{
    // Выбираем первую тему и первую фишку из доступных.
    ТЕМА = мир.реестрМаджонга["🀄"][0]["📦"];
    ФИШКА = мир.реестрМаджонга["🀄"][0]["📁"][42];
    
    мир.полигональныеСетки = {
        [ТЕМА]: {
            [ФИШКА]: null,
        },
    };

    мир.текстуры = {
        [ТЕМА]: { },
    };
    var м = мир.модули.модульПоУказателю(ТЕМА);
    var файлы = Object.keys(м.структура).sort();
    for (var номер in файлы)
    {
        var файл = файлы[номер];
        мир.текстуры[ТЕМА][файл] = null;
    }
};


// // // //


ПлавноУбратьСтраницуЗагрузкиИСкрытьКрутилку = мир =>
{
    плавноСкрытьИУдалить("экран-загрузки", { "задержка": 0.4 });
    плавноСкрыть("крутилка", { "задержка": 0.4 });
};